#re-initialize if players abandoned
execute if entity @a unless entity @a[tag=lobby] run function sprint_racer:game_logic/0/_initialize

#give proper tags to players and spectators
tag @a[tag=!forcespectate,tag=!afk] add playing
team join player @a[team=!player,tag=!forcespectate,tag=!afk]
tag @a[tag=forcespectate] remove playing
team join spectator @a[team=!spectator,tag=forcespectate]
tag @a[tag=afk] remove playing
team join spectator @a[team=!spectator,tag=afk]
tag @a[x=1550,y=108,z=406,distance=..150] add lobby
execute as @a[tag=afk] at @s run function sprint_racer_language:afk_tag

scoreboard players remove @a[scores={subtitleDelay=1..}] subtitleDelay 1

#heals for all
effect give @a[scores={hp=..19}] instant_health 1 10 true

#item stuff
execute if entity @e[tag=optNoItems] run kill @e[tag=itemcontainer]
execute if entity @e[tag=optNoItems] run scoreboard players set @e[tag=node,tag=itemchest,scores={nodeState=1..}] itemBlockState 5
execute if entity @e[name=w,tag=optItems,scores={itemBlockState=30}] run function sprint_racer:game_logic/0/item_stuff
function sprint_racer:items/container_tick_lobby

#don't afk players who are reading...
scoreboard players remove @a[scores={afkTime=500..599},nbt={SelectedItem:{id:"minecraft:written_book"}}] afkTime 2

#allow players to un-afk themselves
execute as @a[tag=afk,scores={moveState=1..}] run function sprint_racer_language:afk_tag_remove
execute as @a[tag=afk,scores={pressJump=1..}] run function sprint_racer_language:afk_tag_remove
execute as @a[tag=afk,scores={carrotInput=..9}] run function sprint_racer_language:afk_tag_remove
scoreboard players reset @a[scores={pressJump=1..}] pressJump

#speedometer display when both enabled and active player count is 1
execute if entity @e[name=w,scores={playerCount=1}] run tag @e[name=w] add speedo
execute if entity @e[name=w,scores={playerCount=2..}] run tag @e[name=w] remove speedo
execute if entity @e[name=w,scores={playerCount=..0}] run bossbar set minecraft:speedo players
execute if entity @e[name=w,scores={playerCount=2..}] run bossbar set minecraft:speedo players

#misc lobby stuff
function sprint_racer:game_logic/0/misc_lobby_happenings/_main


#actionbar display
function sprint_racer_language:lobby/actionbar_display_lobby

#give tips on how to vote and declare self ready
execute as @a[scores={actionbarState=1},nbt={SelectedItem:{tag:{Tags:["readyup","red"]}}}] run function sprint_racer_language:lobby/actionbar_control_tips/ready
execute as @a[scores={actionbarState=1},nbt={SelectedItem:{tag:{Tags:["readyup","green"]}}}] run function sprint_racer_language:lobby/actionbar_control_tips/not_ready
execute as @a[scores={actionbarState=1},nbt={SelectedItem:{tag:{Tags:["mapv"]},id:"minecraft:filled_map"}}] run function sprint_racer_language:lobby/actionbar_control_tips/vote
execute as @a[scores={actionbarState=1},nbt={SelectedItem:{tag:{Tags:["wmPreview"]},id:"minecraft:filled_map"}}] run function sprint_racer_language:lobby/actionbar_control_tips/choose
execute as @a[scores={actionbarState=1}] unless entity @s[nbt={SelectedItem:{}}] run title @s actionbar [""]
execute as @a[scores={actionbarState=1}] unless entity @s[nbt={SelectedItem:{tag:{Tags:["itemhastitle"]}}}] run title @s actionbar [""]

#give books detailing how to play
tag @a remove hasBooks
tag @a[nbt={Inventory:[{Slot:6b,tag:{Tags:["guidebook1"]}},{Slot:7b,tag:{Tags:["guidebook2"]}},{Slot:8b,tag:{Tags:["guidebook3"]}}]}] add hasBooks
clear @a[tag=!hasBooks] written_book
execute as @a[gamemode=adventure,tag=!hasBooks,scores={hp=1..}] run function sprint_racer_language:lobby/guide_books

#give ready-up item
tag @a remove hasRU
tag @a[tag=playing,nbt={Inventory:[{Slot:4b,tag:{Tags:["readyup"]}}]}] add hasRU
clear @a[tag=!hasRU] red_concrete
clear @a[tag=!hasRU] lime_concrete
function sprint_racer_language:lobby/ready_up_item

#spectators and AFK players see a different icon that is not used
tag @a remove hasBLOCK
tag @a[tag=!playing,nbt={Inventory:[{Slot:4b,tag:{Tags:["inform"]}}]}] add hasBLOCK
clear @a[tag=!hasBLOCK] gray_stained_glass
clear @a[tag=!hasBLOCK] pink_stained_glass
function sprint_racer_language:lobby/inform_item

#right-click concrete to toggle ready
execute as @a[tag=playing,scores={inputCooldown=..0,carrotInput=1..},nbt={SelectedItem:{tag:{Tags:["readyup","red"]}}}] at @s run function sprint_racer:game_logic/0/self_ready
execute as @a[tag=playing,scores={inputCooldown=..0,carrotInput=1..},nbt={SelectedItem:{tag:{Tags:["readyup","green"]}}}] at @s run function sprint_racer:game_logic/0/self_not_ready
execute as @a[tag=!playing,scores={inputCooldown=..0,carrotInput=1..},nbt={SelectedItem:{tag:{Tags:["inform","pink"]}}}] at @s run function sprint_racer_language:lobby/inform_spectator
#execute as @a[tag=!playing,scores={inputCooldown=..0,carrotInput=1..},nbt={SelectedItem:{tag:{Tags:["inform","gray"]}}}] at @s run function sprint_racer_language:lobby/inform_afk

#######################
#DETERMINE IF PLAYERS ARE READY OR NOT
#number of ready players required to start is the total divided by 2
#calculate required players
scoreboard players operation @e[name=w] readyDummy = @e[name=w,limit=1] playerCountB
scoreboard players set @e[name=w] math 2
scoreboard players operation @e[name=w] readyDummy /= @e[name=w,limit=1] math
scoreboard players operation @e[name=w] readyRequired = @e[name=w,limit=1] readyDummy
scoreboard players add @e[name=w] readyRequired 1
scoreboard players set @e[name=w,scores={readyRequired=..0}] readyRequired 1

#calculate ready players
scoreboard players set @e[name=w] readyDummy 0
execute as @a[tag=playing,tag=readyup] run scoreboard players add @e[name=w] readyDummy 1
scoreboard players operation @e[name=w] readyCount = @e[name=w,limit=1] readyDummy

#take (ready players) - (required ready players)
#if result is 0 or greater, get the lobby enters into "ready" mode and track is selected
scoreboard players operation @e[name=w] readyDummy -= @e[name=w,limit=1] readyRequired
execute if entity @e[name=w,scores={readyDummy=0..,readyState=..0}] run function sprint_racer:game_logic/0/set_mode_ready
execute if entity @e[name=w,scores={readyDummy=..-1,readyState=1..}] run function sprint_racer:game_logic/0/set_mode_not_ready
#######################


#choose between "ready" menu logic and "not ready" menu logic
execute if entity @e[name=w,scores={readyState=..0}] run function sprint_racer:game_logic/0/gl0_main_not_ready
execute if entity @e[name=w,scores={readyState=1..}] run function sprint_racer:game_logic/0/gl0_main_ready


#keep players from escaping the lobby
execute unless entity @e[name=w,tag=choosingtrack] as @a[gamemode=adventure] at @s if block ~ 59 ~ water unless block ~ 0 ~ yellow_wool run function sprint_racer:game_logic/0/goto_spawn